require 'bcrypt'
require 'base64'
require_relative 'login_helper'

module Teamster
  module Core
    class Login < Sinatra::Base
      @@referrer = nil
      @@root = Dir.pwd
      USERS_FILE  = './data/users'

      configure do
        set :root, @@root
        set :views, "#{settings.root}/views"
        set :users, YAML.load_file("#{settings.root}/#{USERS_FILE}").fetch("users")
        set :referrer, nil
      end

      helpers GeneralHelper, LoginHelper

      get '/login/?' do
        referrer URI::parse(request.referrer)
        erb :login
      end

      post '/login' do
        if user = settings.users.find {|u| u['name'] == params[:user]}
          if BCrypt::Password.new(decode(user['pass'])) == params[:pass]
            session[:current_user] = user['name']
            redirect_back
          else
            login_error
          end
        else
          login_error
        end
      end

      get '/logout/?' do
        referrer URI::parse(request.referrer)
        session[:current_user] = nil
        redirect_back
      end

      def self.referrer
        @@referrer
      end

      def self.set_referrer_to(path)
        @@referrer = path
      end
    end
  end
end
